<?php
if ( ! defined( 'ABSPATH' ) ) { 
    exit; // Exit if accessed directly
}


// add the field to user's own profile editing screen
add_action('edit_user_profile','swal_usermeta_consent',20);
 
// add the field to user profile editing screen
add_action('show_user_profile','swal_usermeta_consent',20);
 

/**
 * The field on the editing screens.
 *
 * @param $user WP_User user object
 */
function swal_usermeta_consent($user)
{
    $user_id        = $user->ID;
    $gdpr_consent   = esc_attr(get_user_meta($user_id, 'user_gdpr_consent', true));

    //$current_screen = get_current_screen();

    ?>
    <div class="tabscontent">
    <h3><?php esc_html_e('GDPR consent','sw-ajax-login') ?></h3>
    <div class="form-table">
    	<?php 

        if ($gdpr_consent) {
            $gdpr_consent_message = '<span class="swal-gdpr-column">'.esc_html__('User gives GDPR consent', 'sw-ajax-login' ).'</span>';
        } else {
            $gdpr_consent_message = esc_html__('User doesn\'t give GDPR consent', 'sw-ajax-login' );
        }
        echo $gdpr_consent_message;
        ?>
    </div>
    <?php
}

/**
  * Adds a GDPR consent column to the user display dashboard.
  *
  * @param  $columns    The array of columns that are displayed on the user dashboard
  * @return         The updated array of columns now including GDPR consent.
  */

add_filter( 'manage_users_columns', 'theme_add_user_gdpr_column' );

 function theme_add_user_gdpr_column( $columns ) {

     $columns['user_gdpr_consent'] = __( 'Consent', 'sw-ajax-login' );
     return $columns;

 } 

 
 
/**
  * Populates the GDPR consent column with the specified user's GDPR consent.
  *
  * @param  $value      An empty string
  * @param  $column_name    The name of the column to populate
  * @param  $user_id    The ID of the user for which we're working with
  * @return         The GDPR consent associated with the user
  */

add_action( 'manage_users_custom_column', 'theme_show_user_gdpr_data', 10, 3 );

 function theme_show_user_gdpr_data( $value, $column_name, $user_id ) {

     if( 'user_gdpr_consent' == $column_name ) {

        $gdpr_consent   = esc_attr(get_user_meta($user_id, 'user_gdpr_consent', true));

        if ($gdpr_consent) {
                    $value = '<span class="swal-gdpr-column">'.esc_html__('GDPR', 'sw-ajax-login' ).'</span>';
                } 

         
     }
     return $value;
 }

?>